unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, Mask, JvExMask, JvSpin;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    Button1: TButton;
    Edit2: TEdit;
    CheckBox1: TCheckBox;
    Label2: TLabel;
    Button2: TButton;
    Bevel1: TBevel;
    PaintBox2: TPaintBox;
    BitBtn1: TBitBtn;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Button3: TButton;
    Button4: TButton;
    sbBlock: TScrollBar;
    Label1: TLabel;
    Bevel2: TBevel;
    Edit1: TEdit;
    Button5: TButton;
    spDivisor: TJvSpinEdit;
    spSandWidth: TJvSpinEdit;
    spWaterLevel: TJvSpinEdit;
    edRandSeed: TJvSpinEdit;
    SaveDialog1: TSaveDialog;
    cbFill: TCheckBox;
    Label6: TLabel;
    spSteepness: TJvSpinEdit;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure sbBlockChange(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1                       : TForm1;

implementation

{$R *.DFM}

uses
  Math;

type
  Grid_Type = array[0..129, 0..129] of single;

const
  Pow2                        : array[0..14] of integer = (
    1, 2, 4, 8, 16, 32, 64, 128, 256, 512, 1024, 2048, 4096, 8192, 16384
    );

var
  Grid                        : Grid_Type;
  TempGrid                    : Grid_Type;
  NRand                       : integer;
  Arand                       : single;
  GaussAdd                    : single;
  GaussFac                    : single;

function MKRGB(c: integer): TColor;
begin
  if c < 0 then
    Result := RGB(0, 0, 0)
  else if c > 255 then
    Result := RGB(255, 255, 255)
  else
    Result := RGB(c, c, c);
end;

function Gauss: single;
var
  Sum                         : single;
  i                           : integer;
begin
  Sum := 0.0;
  for i := 1 to Nrand do begin
    Sum := Sum + Random;
  end;
  Result := GaussFac * Sum - GaussAdd;
end;

procedure Mid_Point_FM_2D(var Grid: Grid_Type;
  Max_Level: integer;
  Sigma, H: single;
  Addition: Boolean);

  function f3(Diff, x0, x1, x2: single): single;
  begin
    Result := (x0 + x1 + x2) / 3.0 + Diff * Gauss;
  end;

  function f4(Diff, x0, x1, x2, x3: single): single;
  begin
    Result := (x0 + x1 + x2 + x3) / 4.0 + Diff * Gauss;
  end;

var
  N                           : integer;
  Diff                        : single;
  x1                          : integer;
  y1                          : integer;
  d1, D2                      : integer;
  Stage                       : integer;

begin
  Max_Level := 0;

  for x1 := 0 to 127 do
    for y1 := 0 to 127 do
      Grid[x1, y1] := 0.0;

  while (Pow2[Max_Level + 1] <= 129) and
    (Pow2[Max_Level + 1] <= 129) do begin
    Inc(Max_Level);
  end;
  Randomize;
  N := Pow2[Max_Level];
  Diff := Sigma;

  Grid[0, 0] := Diff * Gauss;
  Grid[0, N] := Diff * Gauss;
  Grid[N, 0] := Diff * Gauss;
  Grid[N, N] := Diff * Gauss;

  D2 := N;

  d1 := N div 2;

  for Stage := 1 to Max_Level do begin
    Diff := Diff * Power(0.5, (0.5 * H));
    x1 := d1;
    while x1 <= (N - d1) do begin
      y1 := d1;
      while y1 <= (N - d1) do begin
        Grid[x1, y1] := f4(Diff,
          Grid[x1 + d1, y1 + d1],
          Grid[x1 + d1, y1 - d1],
          Grid[x1 - d1, y1 + d1],
          Grid[x1 - d1, y1 - d1]);
        Inc(y1, D2);
      end;
      Inc(x1, D2);
    end;

    if Addition then begin
      x1 := d1;
      while x1 <= (N - d1) do begin
        y1 := d1;
        while y1 <= (N - d1) do begin
          Grid[x1, y1] := Grid[x1, y1] + Diff * Gauss;
          Inc(y1, D2);
        end;
        Inc(x1, D2);
      end;
    end;

    Diff := Diff * Power(0.5, (0.5 * H));

    x1 := d1;

    while x1 <= (N - d1) do begin
      Grid[x1, 0] := f3(Diff,
        Grid[x1 + d1, 0],
        Grid[x1 - d1, 0],
        Grid[x1, d1]);
      Grid[x1, N] := f3(Diff,
        Grid[x1 + d1, N],
        Grid[x1 - d1, N],
        Grid[x1, N - d1]);
      Grid[0, x1] := f3(Diff,
        Grid[0, x1 + d1],
        Grid[0, x1 - d1],
        Grid[d1, x1]);
      Grid[N, x1] := f3(Diff,
        Grid[N, x1 + d1],
        Grid[N, x1 - d1],
        Grid[N - d1, x1]);
      Inc(x1, D2);
    end;

    x1 := d1;

    while x1 <= (N - d1) do begin
      y1 := D2;
      while y1 <= (N - d1) do begin
        Grid[x1, y1] := f4(Diff,
          Grid[x1, y1 + d1],
          Grid[x1, y1 - d1],
          Grid[x1 + d1, y1],
          Grid[x1 - d1, y1]);
        Inc(y1, D2);
      end;
      Inc(x1, D2);
    end;

    x1 := D2;

    while x1 <= (N - d1) do begin
      y1 := d1;
      while y1 <= (N - d1) do begin
        Grid[x1, y1] := f4(Diff,
          Grid[x1, y1 + d1],
          Grid[x1, y1 - d1],
          Grid[x1 + d1, y1],
          Grid[x1 - d1, y1]);
        Inc(y1, D2);
      end;
      Inc(x1, D2);
    end;

    if Addition then begin
      x1 := 0;
      while (x1 <= N) do begin
        y1 := 0;
        while (y1 <= N) do begin
          Grid[x1, y1] := Grid[x1, y1] + Diff * Gauss;
          Inc(y1, D2);
        end;
        Inc(x1, D2);
      end;
      x1 := d1;
      while x1 <= (N - d1) do begin
        y1 := d1;
        while y1 <= (N - d1) do begin
          Grid[x1, y1] := Grid[x1, y1] + Diff * Gauss;
          Inc(y1, D2);
        end;
        Inc(x1, D2);
      end;
    end;
    D2 := D2 div 2;
    d1 := d1 div 2;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  i, j                        : integer;
  ming, maxg                  : single;
  sigma, h                    : single;
  C                           : TColor;
  L                           : integer;
  Hgt                         : integer;
  ClH                         : integer;
  WaterLevel                  : integer;
  SandWidth                   : integer;
  Divisor                     : single;
  bf                          : integer;
  k, r, lim                   : integer;
begin

  RandSeed := StrToInt(edRandSeed.Text);
  Sigma := 1.0;
  H := StrToFloat(Edit2.Text);
  WaterLevel := spWaterLevel.AsInteger;
  SandWidth := spSandWidth.AsInteger;
  Divisor := spDivisor.Value;
  bf := Pow2[sbBlock.Position];

  if Assigned(Sender) then
    Mid_Point_FM_2D(Grid, 0, Sigma, H, CheckBox1.Checked);

  ming := 99999;
  maxg := -99999;
  for i := 0 to 127 do begin
    for j := 0 to 127 do begin
      if Grid[i, j] < ming then
        ming := Grid[i, j];
      if Grid[i, j] > maxg then
        maxg := Grid[i, j];
    end
  end;

  PaintBox2.Canvas.FillRect(PaintBox2.Canvas.ClipRect);
  for i := 0 to 127 do begin
    for j := 0 to 127 do begin
      Hgt := -Trunc(255 * Grid[i, j] / (maxg - ming));
      C := MKRGB(Hgt);
      PaintBox1.Canvas.Pixels[i * 2 + 0, j * 2 + 0] := C;
      PaintBox1.Canvas.Pixels[i * 2 + 1, j * 2 + 0] := C;
      PaintBox1.Canvas.Pixels[i * 2 + 0, j * 2 + 1] := C;
      PaintBox1.Canvas.Pixels[i * 2 + 1, j * 2 + 1] := C;

      Hgt := -Trunc(255 * Grid[127 - i, j] / (maxg - ming) / Divisor);
      C := RGB(0, 120 - (Hgt - WaterLevel - SandWidth), 0);
      if (Hgt <= WaterLevel) then begin
        Hgt := WaterLevel;
        L := Hgt div 3 + 1;
        ClH := Hgt;
        C := clNavy;
      end
      else begin
        ;
        L := Hgt div 3;
        ClH := Hgt - WaterLevel;
        if (ClH > 35 + SandWidth + WaterLevel) then begin
          C := (ClH - 35 - SandWidth - WaterLevel) * 2 + 50;
          if C > 240 then
            C := 240;
          C := RGB(C, C, C);
        end;
        if (ClH <= SandWidth) then begin
          C := RGB(200 - ClH * 120 div SandWidth, 200 - ClH * 120 div SandWidth, 60);
        end;
      end;

      if (i = 127) or (j = 127) then
        C := clGray;
      if ((i mod bf) = 0) and ((j mod bf) = 0) then begin
        PaintBox2.Canvas.Pen.Color := C;
        lim := bf - 1;
        if bf > 2 then begin
          if bf > 1 then
            lim := bf - 2;
          L := ((hgt shr sbBlock.Position) shl sbBlock.Position) div 3 + 1;
        end;
        for k := 0 to lim do begin
          for r := 0 to lim do begin
            PaintBox2.Canvas.MoveTo(150 - i + j - k + r, (i + j) div 2 + 100 + (k + r) div 2);
            PaintBox2.Canvas.LineTo(150 - i + j - k + r, (i + j) div 2 + 100 - L + (k + r) div 2);
          end
        end
      end
    end
  end;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
  i, j                        : integer;
  ming, maxg                  : single;
  C                           : TColor;
  L                           : integer;
  Hgt                         : integer;
  ClH                         : integer;
  WaterLevel                  : integer;
  SandWidth                   : integer;
  Divisor                     : single;
  bf                          : integer;
  lim                         : integer;
  d                           : integer;
  x, y, z                     : integer;
  LastZ                       : Integer;
  Last3Z                      : Integer;
  OutFile                     : TextFile;
  Last                        : integer;
  Steepness                   : Integer;
begin
  WaterLevel := spWaterLevel.AsInteger;
  SandWidth := spSandWidth.AsInteger;
  Divisor := spDivisor.Value;
  Steepness := 17 - spSteepness.AsInteger;
  bf := Pow2[sbBlock.Position];

  if SaveDialog1.Execute then begin
    AssignFile(OutFile, SaveDialog1.FileName);
    Rewrite(OutFile);

    try
      ming := 99999;
      maxg := -99999;
      for i := 0 to 127 do begin
        for j := 0 to 127 do begin
          if Grid[i, j] < ming then
            ming := Grid[i, j];
          if Grid[i, j] > maxg then
            maxg := Grid[i, j];
        end
      end;

      d := (128 div bf) div 2;
      for x := -d to d - 1 do begin
        i := (x + d) * bf;
        for y := -d to d - 1 do begin
          j := (y + d) * bf;
          Hgt := -Trunc(255 * Grid[127 - i, j] / (maxg - ming) / Divisor);
          C := RGB(0, 120 - (Hgt - WaterLevel - SandWidth), 0);
          if (Hgt <= WaterLevel) then begin
            Hgt := WaterLevel;
            L := Hgt div Steepness;
            ClH := Hgt;
            C := clNavy;
          end
          else begin
            L := Hgt div Steepness;
            ClH := Hgt - WaterLevel;
            if (ClH > 35 + SandWidth + WaterLevel) then begin
              C := (ClH - 35 - SandWidth - WaterLevel) * 2 + 50;
              if C > 240 then
                C := 240;
              C := RGB(C, C, C);
            end;
            if (ClH <= SandWidth) then begin
              C := RGB(200 - ClH * 120 div SandWidth, 200 - ClH * 120 div SandWidth, 60);
            end;
          end;
          z := 0;
          Last := 1;
          Last3Z := 9999;
          while L >= 0 do begin
            if L >= 3 then begin
              if cbFill.Checked then
                WriteLn(OutFile, Format('B %d %d %d 1 1 3 %d 1 0 0 0 0', [x, y, z, integer(c)]));
              Last := 3;
              LastZ := z;
              Last3Z := z;
              Dec(L, 3);
              Inc(z, 3);
            end
            else begin
              if cbFill.Checked then
                WriteLn(OutFile, Format('B %d %d %d 1 1 1 %d 1 0 0 0 0', [x, y, z, integer(c)]));
              Last := 1;
              LastZ := z ;
              Dec(L, 1);
              Inc(z, 1);
            end
          end;
          if not cbFill.Checked then
            case Last of
              1: begin
                  if Last3Z < LastZ then
                    WriteLn(OutFile, Format('B %d %d %d 1 1 3 %d 1 0 0 0 0', [x, y, Last3Z, integer(c)]));
                  WriteLn(OutFile, Format('B %d %d %d 1 1 1 %d 1 0 0 0 0', [x, y, LastZ, integer(c)]));
                end;
              3: begin
                  WriteLn(OutFile, Format('B %d %d %d 1 1 3 %d 1 0 0 0 0', [x, y, Last3Z, integer(c)]));
                end;
            end;
            Last3Z := 9999;
        end
      end;
    finally
      CloseFile(OutFile);
    end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  edRandSeed.Text := IntToStr(RandSeed);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  edRandSeed.Text := IntToStr(GetTickCount);
  Button1Click(Sender);
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var
  i, j                        : integer;
begin
  TempGrid := Grid;
  for i := 0 to 127 do
    for j := 0 to 127 do
      Grid[i, j] := TempGrid[j, 127 - i];
  Button1Click(nil);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Button1Click(nil);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  spDivisor.Value := 1.0;
  spSandWidth.Value := 20;
  spWaterLevel.Value := 1;
  Button1Click(nil);
end;

procedure TForm1.sbBlockChange(Sender: TObject);
begin
  Edit1.Text := IntToStr(Pow2[7 - sbBlock.Position]);
  Button1Click(nil);
end;

initialization
  NRand := 4;
  Arand := 1.0;
  GaussAdd := Sqrt(3 * Nrand);
  GaussFac := 2.0 * GaussAdd / (Nrand * Arand);
end.

